/*
 *Grabber Plugin
 */

new const String:PLUGIN_VERSION[60] = "1.1.5.138";

public Plugin:myinfo = {
	
	name = "GravityGun",
	author = "FlaminSarge, javalia",
	description = "Grab it!",
	version = PLUGIN_VERSION,
	url = "http://www.sourcemod.net/"
	
};

//인클루드문장
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <vphysics>
#include <stocklib>
#include <matrixmath>

#include "GravityGun/GravityGunsound.inc"
#include "GravityGun/GravityGuncvars.inc"

#define EFL_NO_PHYSCANNON_INTERACTION (1<<30)

//문법정의
#pragma semicolon 1

enum PropTypeCheck{

	PROP_NONE = 0,
	PROP_RIGID = 1,
	PROP_PHYSBOX = 2,
	PROP_WEAPON = 3,
	PROP_TF2OBJ = 4,//tf2 buildings
	PROP_RAGDOLL = 5,
	PROP_TF2PROJ = 6//tf2 projectiles

};

//are they using grabber?
//new bool:grabenabled[MAXPLAYERS + 1];

new bool:g_bIsWeaponGrabber[MAXPLAYERS + 1];

//which entity is grabbed?(and are we currently grabbing anything?) this is entref, not ent index
new grabbedentref[MAXPLAYERS + 1] = {INVALID_ENT_REFERENCE, ...};

new keybuffer[MAXPLAYERS + 1];

new Float:grabangle[MAXPLAYERS + 1][3];
//new Float:grabpos[MAXPLAYERS + 1][3];

new Float:grabdistance[MAXPLAYERS + 1];

new Float:preeyangle[MAXPLAYERS + 1][3];
new Float:playeranglerotate[MAXPLAYERS + 1][3];

new Float:nextactivetime[MAXPLAYERS + 1];

new bool:entitygravitysave[MAXPLAYERS + 1];
new entityownersave[MAXPLAYERS + 1] = {INVALID_ENT_REFERENCE, ...};

new PropTypeCheck:grabentitytype[MAXPLAYERS + 1];

new Handle:forwardOnClientGrabEntity = INVALID_HANDLE;
new Handle:forwardOnClientDragEntity = INVALID_HANDLE;
new Handle:forwardOnClientEmptyShootEntity = INVALID_HANDLE;
new Handle:forwardOnClientShootEntity = INVALID_HANDLE;

public OnPluginStart(){
	
	HookEvent("player_spawn", EventSpawn);
	creategravityguncvar();
	for (new client = 0; client <= MaxClients; client++)
	{
		g_bIsWeaponGrabber[client] = false;

		grabbedentref[client] = INVALID_ENT_REFERENCE;
		if (isClientConnectedIngame(client))
		{
			SDKHook(client, SDKHook_PreThink, PreThinkHook);
			SDKHook(client, SDKHook_WeaponSwitch, WeaponSwitchHook);
		}
	}
	//LoadTranslations("gravitygun.phrases");
	
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max){

	CreateNative("GG_GetCurrentHeldEntity", Native_GetCurrntHeldEntity);
	CreateNative("GG_ForceDropHeldEntity", Native_ForceDropHeldEntity);
	CreateNative("GG_ForceGrabEntity", Native_ForceGrabEntity);
	
	forwardOnClientGrabEntity = CreateGlobalForward("OnClientGrabEntity", ET_Event, Param_Cell, Param_Cell);
	forwardOnClientDragEntity =  CreateGlobalForward("OnClientDragEntity", ET_Event, Param_Cell, Param_Cell);
	forwardOnClientEmptyShootEntity =  CreateGlobalForward("OnClientEmptyShootEntity", ET_Event, Param_Cell, Param_Cell);
	forwardOnClientShootEntity =  CreateGlobalForward("OnClientShootEntity", ET_Event, Param_Cell, Param_Cell);
	
	RegPluginLibrary("GravityGun");
	
	return APLRes_Success;
	
}

public OnMapStart(){
	
	prepatchsounds();

	AutoExecConfig();
	
}

public Action:EventSpawn(Handle:Event, const String:Name[], bool:Broadcast){
	
	decl client;
	client = GetClientOfUserId(GetEventInt(Event, "userid"));
	
	nextactivetime[client] = GetGameTime();
	
}

public OnClientPutInServer(client){
	
	g_bIsWeaponGrabber[client] = false;
	
	grabbedentref[client] = INVALID_ENT_REFERENCE;
	
	SDKHook(client, SDKHook_PreThink, PreThinkHook);
	SDKHook(client, SDKHook_WeaponSwitch, WeaponSwitchHook);

}

public OnClientDisconnect(client){
	
	//we must release any thing if it is on spectator`s hand
	release(client);
	
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon){

	if(isClientConnectedIngameAlive(client)){
		
		if(clientisgrabbingvalidobject(client)){
		
			if(buttons & IN_USE){
			
				ZeroVector(vel);
				
				if(buttons & IN_MOVELEFT){
					
					buttons &= ~IN_MOVELEFT;
					playeranglerotate[client][1] = playeranglerotate[client][1] - 1.0;
				
				}else if(buttons & IN_MOVERIGHT){
				
					buttons &= ~IN_MOVERIGHT;
					playeranglerotate[client][1] = playeranglerotate[client][1] + 1.0;
				
				}
				
				if(buttons & IN_FORWARD){
				
					buttons &= ~IN_FORWARD;
					
					playeranglerotate[client][0] = playeranglerotate[client][0] + 1.0;
					
				
				}else if(buttons & IN_BACK){
				
					buttons &= ~IN_BACK;
					playeranglerotate[client][0] = playeranglerotate[client][0] - 1.0;
					
				
				}
			
			}
			
			if(buttons & IN_RELOAD){
				
				ZeroVector(vel);
				
				if(buttons & IN_MOVELEFT){
					
					buttons &= ~IN_MOVELEFT;
					playeranglerotate[client][2] = playeranglerotate[client][2] - 1.0;
				
				}else if(buttons & IN_MOVERIGHT){
				
					buttons &= ~IN_MOVERIGHT;
					playeranglerotate[client][2] = playeranglerotate[client][2] + 1.0;
				
				}
				
				if(buttons & IN_FORWARD){
				
					buttons &= ~IN_FORWARD;
					
					if(buttons & IN_SPEED){
					
						grabdistance[client] = grabdistance[client] + 10.0;
					
					}else{
					
						grabdistance[client] = grabdistance[client] + 1.0;
						
					}
					
					if(grabdistance[client] >= GetConVarFloat(cvar_grab_maxdistance)){
					
						grabdistance[client] = GetConVarFloat(cvar_grab_maxdistance);
					
					}
				
				}else if(buttons & IN_BACK){
				
					buttons &= ~IN_BACK;
					
					if(buttons & IN_SPEED){
					
						grabdistance[client] = grabdistance[client] - 10.0;
					
					}else{
					
						grabdistance[client] = grabdistance[client] - 1.0;
						
					}
					
					if(grabdistance[client] < GetConVarFloat(cvar_grab_mindistance)){
					
						grabdistance[client] = GetConVarFloat(cvar_grab_mindistance);
					
					}
				
				}
			
			}
			
		}
		
	}
	
	return Plugin_Continue;

}

public Action:WeaponSwitchHook(client, entity){
	
	decl String:weaponname[64];
	if(!isClientConnectedIngameAlive(client) || !IsValidEntity(entity)){
		
		g_bIsWeaponGrabber[client] = false;
		return Plugin_Continue;
		
	}
	
	GetEdictClassname(entity, weaponname, sizeof(weaponname));
	
	//magic number is bad but i am to sleepy to make new defines
	new rulecheck = GetConVarInt(g_cvarWeaponSwitchRule);
	
	//현재 든 무기가 중력건 기능이 없거나, 기능을 가지고 있어도 물건을 들고있지 않은가
	if(!isWeaponGrabber(GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon")) || EntRefToEntIndex(grabbedentref[client]) == -1 || !Phys_IsPhysicsObject(EntRefToEntIndex(grabbedentref[client]))){
		
		//든 물건이 없으므로, 바꾸기를 허락
		g_bIsWeaponGrabber[client] = isWeaponGrabber(entity);
		return Plugin_Continue;
	
	}else{
		
		//물건을 든 상태에서는 무기 바꾸기를 허락하지 않는다
		if(rulecheck == 0){
			
			return Plugin_Handled;
			
		}else{
		
			g_bIsWeaponGrabber[client] = isWeaponGrabber(entity);
			if(!g_bIsWeaponGrabber[client] || rulecheck == 1) release(client);
			return Plugin_Continue;
		
		}
		
	}
	
}

public PreThinkHook(client){
	
	if(isClientConnectedIngameAlive(client)){
		
		new buttons = GetClientButtons(client);
		new clientteam = GetClientTeam(client);
		
		if((buttons & IN_USE)  && clientisgrabbingvalidobject(client)){
		
			//SetEntityFlags(client, GetEntityFlags(client) & FL_ONTRAIN);
			
			//e키를 누른 상태로 공격 버튼을 누르면 멈춘 것은 풀고, 푼 것은 얼린다
			if(buttons & IN_ATTACK && !(keybuffer[client] & IN_ATTACK) && GetConVarBool(g_cvarEnableMotionControl)){
				
				if(Phys_IsMotionEnabled(EntRefToEntIndex(grabbedentref[client]))){
					
					keybuffer[client] = keybuffer[client] | IN_ATTACK;
					AcceptEntityInput(grabbedentref[client], "DisableMotion");
					playsoundfromclient(client, SOUNDTYPE_GRAVITYGUN_MOTION);
					release(client);
					return;
				
				}else{
					
					keybuffer[client] = keybuffer[client] | IN_ATTACK;
					AcceptEntityInput(grabbedentref[client], "EnableMotion");
					playsoundfromclient(client, SOUNDTYPE_GRAVITYGUN_MOTION);
					return;
				
				}
			
			}
			
			if(buttons & IN_SPEED){
			
				grabangle[client][0] = 0.0;
				grabangle[client][1] = 0.0;
				grabangle[client][2] = 0.0;
			
			}else{
		
				//클라이언트의 이전 눈 각도에 대비해서 현재 각도가 얼마나 변했는지를 구해서 그것을 그랩앵글에 적용한다
				decl Float:nowangle[3];
				GetClientEyeAngles(client, nowangle);
				
				playeranglerotate[client][0] = playeranglerotate[client][0] + (preeyangle[client][0] - nowangle[0]);
				playeranglerotate[client][1] = playeranglerotate[client][1] + (preeyangle[client][1] - nowangle[1]);
				playeranglerotate[client][2] = playeranglerotate[client][2] + (preeyangle[client][2] - nowangle[2]);
				
				clampangle(playeranglerotate[client]);
				
				TeleportEntity(client, NULL_VECTOR, preeyangle[client], NULL_VECTOR);
				
			}
		
		}else{
			
			GetClientEyeAngles(client, preeyangle[client]);
		
		}
		
		//잡은 물건이 있는가? 없는가? any held object?
		if(grabbedentref[client] == INVALID_ENT_REFERENCE){
		
			//잡은 물건이 애초에 없다 no helding at all
		
			if((buttons & IN_ATTACK2) && !(keybuffer[client] & IN_ATTACK2)){
		
				//물건을 잡는다 try to grab something
				if(teamcanusegravitygun(clientteam) && g_bIsWeaponGrabber[client]){
				
					grab(client);
					
				}
			
			}else if(buttons & IN_ATTACK && !(keybuffer[client] & IN_ATTACK)){
			
				//물건을 쏜다 try to shoot something
				if(teamcanusegravitygun(clientteam) && g_bIsWeaponGrabber[client]){
				
					emptyshoot(client);
					
				}
			
			}
			
		}else if(EntRefToEntIndex(grabbedentref[client]) == -1 || !Phys_IsPhysicsObject(EntRefToEntIndex(grabbedentref[client]))){
		
			//잡은 물건이 있었으나 현재는 사라졌다 held object has gone
			grabbedentref[client] = INVALID_ENT_REFERENCE;
			//lets make some release sound of gravity gun.
			stopentitysound(client, SOUND_GRAVITYGUN_HOLD);
			playsoundfromclient(client, SOUNDTYPE_GRAVITYGUN_DROP);
		
		}else{
		
			//현재도 물건을 잡고 있다we are currently helding something now
			
			if(((buttons & IN_ATTACK2) && !(keybuffer[client] & IN_ATTACK2)) || !teamcanusegravitygun(clientteam) || !g_bIsWeaponGrabber[client]){
		
				//물건을 내려놓는다. try to release something
				release(client);
			
			}else if(buttons & IN_ATTACK && !(keybuffer[client] & IN_ATTACK)){
			
				//물건을 쏜다. try to shot something
				shoot(client);
			
			}else{
			
				//물건을 잡은 상태를 유지한다 try to keep helding object
				hold(client);
			
			}
		
		}
		
		if(!(buttons & IN_ATTACK)){
			
			//마우스를 누르고 있지 않으므로 버퍼를 푼다
			keybuffer[client] = keybuffer[client] & ~IN_ATTACK;
			
		}
		if(!(buttons & IN_ATTACK2)){
			
			//마우스2를 누르고 있지 않으므로 버퍼를 푼다
			keybuffer[client] = keybuffer[client] & ~IN_ATTACK2;
			
		}
		
	}else{
		
		//we must release any thing if it is on spectator`s hand
		release(client);
	
	}
	
}

grab(client){

	new targetentity, Float:distancetoentity, Float:resultpos[3];
	
	targetentity = GetClientAimEntity3(client, distancetoentity, resultpos);
	
	if(targetentity != -1){
		
		new PropTypeCheck:entityType = entityTypeCheck(targetentity);
		
		if(entityType && !isClientConnectedIngameAlive(GetEntPropEnt(targetentity, Prop_Send, "m_hOwnerEntity"))){
				
			if(distancetoentity <= GetConVarFloat(cvar_maxpickupdistance)){
			
				//should we allow grab?
				if(GetForwardFunctionCount(forwardOnClientGrabEntity) > 0){
				
					new Action:result;
			   
					Call_StartForward(forwardOnClientGrabEntity);
					Call_PushCell(client);
					Call_PushCell(targetentity);
					Call_Finish(result);
				   
					if(result !=  Plugin_Continue){
					
						return;
					
					}
					
				}
				
				if(!clientcangrab(client)){
			
					return;
				
				}
				if (entityType == PROP_TF2OBJ && GetEntPropEnt(targetentity, Prop_Send, "m_hBuilder") != client)
					return;

				grabentitytype[client] = entityType;
				
				if(entityType == PROP_RIGID){
			
					SetEntProp(targetentity, Prop_Data, "m_bFirstCollisionAfterLaunch", false);
				
				}
				
				new lastowner = GetEntPropEnt(targetentity, Prop_Send, "m_hOwnerEntity");
				
				if(lastowner != INVALID_ENT_REFERENCE){
				
					entityownersave[client] = EntIndexToEntRef(lastowner);
				
				}else{
				
					entityownersave[client] = INVALID_ENT_REFERENCE;
					
				}
				
				SetEntPropEnt(targetentity, Prop_Send, "m_hOwnerEntity", client);
				grabbedentref[client] = EntIndexToEntRef(targetentity);
				
				//SetEntPropEnt(targetentity, Prop_Data, "m_hParent", client);
				
				//SetEntProp(targetentity, Prop_Data, "m_iEFlags", GetEntProp(targetentity, Prop_Data, "m_iEFlags") | EFL_NO_PHYSCANNON_INTERACTION);
				
				entitygravitysave[client] = Phys_IsGravityEnabled(targetentity);
				
				Phys_EnableGravity(targetentity, false);
				
				decl Float:clienteyeangle[3], Float:entityangle[3];//, Float:entityposition[3];
				GetEntPropVector(grabbedentref[client], Prop_Send, "m_angRotation", entityangle);
				GetClientEyeAngles(client, clienteyeangle);
				
				playeranglerotate[client][0] = 0.0;
				playeranglerotate[client][1] = 0.0;
				playeranglerotate[client][2] = 0.0;
				
				grabangle[client][0] = 0.0;
				grabangle[client][1] = 0.0;
				grabangle[client][2] = 0.0;
				
				grabdistance[client] = GetConVarFloat(cvar_grab_defaultdistance);
				/* GetEntPropVector(grabbedentref[client], Prop_Send, "m_vecOrigin", entityposition);
				grabpos[client][0] = entityposition[0] - resultpos[0];
				grabpos[client][1] = entityposition[1] - resultpos[1];
				grabpos[client][2] = entityposition[2] - resultpos[2]; */
				
				new matrix[matrix3x4_t];
				
				matrix3x4FromAnglesNoOrigin(clienteyeangle, matrix);
				
				decl Float:temp[3];
				
				MatrixAngles(matrix, temp);
				
				TransformAnglesToLocalSpace(entityangle, grabangle[client], matrix);
				
				keybuffer[client] = keybuffer[client] | IN_ATTACK2;
				
				playsoundfromclient(client, SOUNDTYPE_GRAVITYGUN_PICKUP);
				playentitysoundfromclient(client, SOUND_GRAVITYGUN_HOLD);
				
			}else if(distancetoentity <= GetConVarFloat(cvar_maxdragdistance)){
				
				if(GetForwardFunctionCount(forwardOnClientDragEntity) > 0){
				
					new Action:result;
			   
					Call_StartForward(forwardOnClientDragEntity);
					Call_PushCell(client);
					Call_PushCell(targetentity);
					Call_Finish(result);
				   
					if(result !=  Plugin_Continue) {
					
						return;
					
					}
					
				}
				
				//그냥 끌어온다
				decl Float:entityposition[3], Float:clientposition[3], Float:vector[3];
				GetEntPropVector(targetentity, Prop_Send, "m_vecOrigin", entityposition);
				GetClientEyePosition(client, clientposition);
				MakeVectorFromPoints(entityposition, clientposition, vector);
				NormalizeVector(vector, vector);
				ScaleVector(vector, GetConVarFloat(cvar_dragforce));
				
				decl Float:ZeroSpeed[3];
				ZeroVector(ZeroSpeed);
				Phys_SetVelocity(targetentity, vector, ZeroSpeed);
//				decl String:netclass[64];
//				GetEntityNetClass(targetentity, netclass, sizeof(netclass));
				if (FindDataMapOffs(targetentity, "m_hPhysicsAttacker") != -1) SetEntPropEnt(targetentity, Prop_Data, "m_hPhysicsAttacker", client);
				if (FindDataMapOffs(targetentity, "m_flLastPhysicsInfluenceTime") != -1) SetEntPropFloat(targetentity, Prop_Data, "m_flLastPhysicsInfluenceTime", GetGameTime());
			
			}
			
		}
	
	}

}

shoot(client){
	
	if(!clientcanpull(client)){
		
		return;
	
	}
	
	if(GetForwardFunctionCount(forwardOnClientShootEntity) > 0){
			
		new Action:result;
   
		Call_StartForward(forwardOnClientShootEntity);
		Call_PushCell(client);
		Call_PushCell(EntRefToEntIndex(grabbedentref[client]));
		Call_Finish(result);
	   
		if(result !=  Plugin_Continue){
		
			return;
		
		}
		
	}
	
	decl Float:clienteyeangle[3], Float:anglevector[3];
	GetClientEyeAngles(client, clienteyeangle);
	GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
	NormalizeVector(anglevector, anglevector);
	ScaleVector(anglevector, GetConVarFloat(cvar_pullforce));
	
	Phys_EnableGravity(EntRefToEntIndex(grabbedentref[client]), entitygravitysave[client]);
	SetEntPropEnt(grabbedentref[client], Prop_Send, "m_hOwnerEntity", EntRefToEntIndex(entityownersave[client]));
	
	decl Float:ZeroSpeed[3];
	ZeroVector(ZeroSpeed);
	TeleportEntity(grabbedentref[client], NULL_VECTOR, NULL_VECTOR, NULL_VECTOR);
	Phys_SetVelocity(EntRefToEntIndex(grabbedentref[client]), anglevector, ZeroSpeed);
	
	SetEntPropEnt(grabbedentref[client], Prop_Send, "m_hOwnerEntity", EntRefToEntIndex(entityownersave[client]) == -1 ? -1 : EntRefToEntIndex(entityownersave[client]));
	
	if(grabentitytype[client] == PROP_RIGID || grabentitytype[client] == PROP_PHYSBOX || grabentitytype[client] == PROP_RAGDOLL){
			
		SetEntPropEnt(grabbedentref[client], Prop_Data, "m_hPhysicsAttacker", client);
		SetEntPropFloat(grabbedentref[client], Prop_Data, "m_flLastPhysicsInfluenceTime", GetGameTime());
		
	}
	if(grabentitytype[client]	== PROP_RIGID){
	
		SetEntProp(grabbedentref[client], Prop_Data, "m_bFirstCollisionAfterLaunch", true);
		SetEntProp(grabbedentref[client], Prop_Data, "m_bThrownByPlayer", true);
	
	}
	
	grabbedentref[client] = INVALID_ENT_REFERENCE;
	
	stopentitysound(client, SOUND_GRAVITYGUN_HOLD);
	if (grabentitytype[client] != PROP_TF2OBJ) playsoundfromclient(client, SOUNDTYPE_GRAVITYGUN_PUNT);

}

emptyshoot(client){
	
	if(!clientcanpull(client)){
		
		return;
	
	}
	
	new targetentity, Float:distancetoentity;
	
	targetentity = GetClientAimEntity(client, distancetoentity);
	
	if(targetentity != -1){
		
		new PropTypeCheck:entityType = entityTypeCheck(targetentity);
		
		if(entityType && (distancetoentity <= GetConVarFloat(cvar_maxpulldistance))  && !isClientConnectedIngameAlive(GetEntPropEnt(targetentity, Prop_Send, "m_hOwnerEntity"))){
		
			if(GetForwardFunctionCount(forwardOnClientEmptyShootEntity) > 0){
				
				new Action:result;
		   
				Call_StartForward(forwardOnClientEmptyShootEntity);
				Call_PushCell(client);
				Call_PushCell(targetentity);
				Call_Finish(result);
			   
				if(result !=  Plugin_Continue){
				
					return;
				
				}
				
			}
			
			decl Float:clienteyeangle[3], Float:anglevector[3];
			GetClientEyeAngles(client, clienteyeangle);
			GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
			NormalizeVector(anglevector, anglevector);
			ScaleVector(anglevector, GetConVarFloat(cvar_pullforce));
			
			decl Float:ZeroSpeed[3];
			ZeroVector(ZeroSpeed);
			//TeleportEntity(targetentity, NULL_VECTOR, NULL_VECTOR, NULL_VECTOR);
			Phys_AddVelocity(targetentity, anglevector, ZeroSpeed);
			
			if(entityType == PROP_RIGID || entityType == PROP_PHYSBOX || entityType == PROP_RAGDOLL){
			
				SetEntPropEnt(targetentity, Prop_Data, "m_hPhysicsAttacker", client);
				SetEntPropFloat(targetentity, Prop_Data, "m_flLastPhysicsInfluenceTime", GetGameTime());
				
			}
			if(entityType == PROP_RIGID){
			
				SetEntProp(targetentity, Prop_Data, "m_bThrownByPlayer", true);
			
			}
			
			if (entityType != PROP_TF2OBJ) playsoundfromclient(client, SOUNDTYPE_GRAVITYGUN_PUNT);
			
		}
	
	}

}

release(client){
	
	if(EntRefToEntIndex(grabbedentref[client]) != -1){
		
		Phys_EnableGravity(EntRefToEntIndex(grabbedentref[client]), entitygravitysave[client]);
		SetEntPropEnt(grabbedentref[client], Prop_Send, "m_hOwnerEntity", EntRefToEntIndex(entityownersave[client]));
		if(isClientConnectedIngame(client)){
	
			playsoundfromclient(client, SOUNDTYPE_GRAVITYGUN_DROP);
			
		}
		
	}
	grabbedentref[client] = INVALID_ENT_REFERENCE;
	keybuffer[client] = keybuffer[client] | IN_ATTACK2;
	
	stopentitysound(client, SOUND_GRAVITYGUN_HOLD);

}

hold(client){
	
	//물건을 어디로 끌어갈지 정한다
	decl Float:resultpos[3], Float:resultvecnormal[3];
	getClientAimPosition(client, grabdistance[client], resultpos, resultvecnormal, tracerayfilterrocket, client);
	
	decl Float:entityposition[3], Float:clientposition[3], Float:vector[3];
	GetEntPropVector(grabbedentref[client], Prop_Send, "m_vecOrigin", entityposition);
	GetClientEyePosition(client, clientposition);
	decl Float:clienteyeangle[3];
	GetClientEyeAngles(client, clienteyeangle);
	
	decl Float:clienteyeangleafterchange[3];
	
	clienteyeangleafterchange[0] = clienteyeangle[0] + playeranglerotate[client][0];
	clienteyeangleafterchange[1] = clienteyeangle[1] + playeranglerotate[client][1];
	clienteyeangleafterchange[2] = clienteyeangle[2] + playeranglerotate[client][2];
	
	decl playerlocalspace[matrix3x4_t], playerlocalspaceafterchange[matrix3x4_t];
	
	matrix3x4FromAnglesNoOrigin(clienteyeangle, playerlocalspace);
	matrix3x4FromAnglesNoOrigin(clienteyeangleafterchange, playerlocalspaceafterchange);
	
	decl Float:resultangle[3];
	
	TransformAnglesToWorldSpace(grabangle[client], resultangle, playerlocalspaceafterchange);
	TransformAnglesToLocalSpace(resultangle, grabangle[client], playerlocalspace);
	
	ZeroVector(playeranglerotate[client]);
	
	MakeVectorFromPoints(entityposition, resultpos, vector);
	ScaleVector(vector, GetConVarFloat(cvar_grabforcemultiply));
	
	//decl Float:entityangle[3], Float:angvelocity[3];
	// GetEntPropVector(grabbedentref[client], Prop_Data, "m_angAbsRotation", entityangle);
	
	// decl targetanglespace[matrix3x4_t], Float:angletomove[3];
	// matrix3x4FromAnglesNoOrigin(resultangle, targetanglespace);
	// TransformAnglesToLocalSpace(entityangle, angletomove, targetanglespace);
	
	//angvelocity[0] = entityangle[0] - resultangle[0];
	//angvelocity[1] = entityangle[1] - resultangle[1];
	//angvelocity[2] = entityangle[2] - resultangle[2];
	
	//ZeroVector(angvelocity);
	// NegateVector(angletomove);
	
	if(grabentitytype[client] != PROP_RAGDOLL){
	
		TeleportEntity(grabbedentref[client], NULL_VECTOR, resultangle, NULL_VECTOR);
		
	}
	
	Phys_SetVelocity(EntRefToEntIndex(grabbedentref[client]), vector, ZERO_VECTOR, true);
	
	if(grabentitytype[client] == PROP_RIGID || grabentitytype[client] == PROP_PHYSBOX || grabentitytype[client] == PROP_RAGDOLL){
			
		SetEntPropEnt(grabbedentref[client], Prop_Data, "m_hPhysicsAttacker", client);
		SetEntPropFloat(grabbedentref[client], Prop_Data, "m_flLastPhysicsInfluenceTime", GetGameTime());
		
	}
	if(grabentitytype[client]	== PROP_RIGID){
	
		SetEntProp(grabbedentref[client], Prop_Data, "m_bThrownByPlayer", true);
	
	}
	
}

PropTypeCheck:entityTypeCheck(entity){

	new String:classname[64];
	GetEdictClassname(entity, classname, 64);
	
	if(StrContains(classname, "prop_physics", false)  != -1){
	
		return PROP_RIGID;
	
	}else if(StrContains(classname, "func_physbox", false)  != -1){
		
		return PROP_PHYSBOX;
	
	}else if(StrContains(classname, "prop_ragdoll", false)  != -1){
	
		return PROP_RAGDOLL;
	
	}else if(StrContains(classname, "weapon_", false)  != -1){
	
		return PROP_WEAPON;
	
	}else if(StrContains(classname, "tf_projectile", false)  != -1){
	
		return PROP_TF2PROJ;
	
	}else if(StrEqual(classname, "obj_sentrygun", false) || StrEqual(classname, "obj_dispenser", false)
			|| StrEqual(classname, "obj_teleporter", false)){
	
		return PROP_TF2OBJ;
	
	}else{
	
		return PROP_NONE;
	
	}

}

bool:clientcanpull(client){

	new Float:now = GetGameTime();
	
	if(nextactivetime[client] <= now){
	
		nextactivetime[client] = now + GetConVarFloat(cvar_pull_delay);
		
		return true;
	
	}
	
	return false;

}

bool:clientcangrab(client){

	new Float:now = GetGameTime();
	
	if(nextactivetime[client] <= now){
	
		nextactivetime[client] = now + GetConVarFloat(cvar_grab_delay);
		
		return true;
	
	}
	
	return false;

}

bool:clientisgrabbingvalidobject(client){

	if(EntRefToEntIndex(grabbedentref[client]) != -1 && Phys_IsPhysicsObject(EntRefToEntIndex(grabbedentref[client]))){
		
		return true;
		
	}else{
	
		return false;
	
	}

}

public Native_GetCurrntHeldEntity(Handle:plugin,  args){

	new client = GetNativeCell(1);
	
	if(isClientConnectedIngameAlive(client)){
		
		return EntRefToEntIndex(grabbedentref[client]);
		
	}else{
	
		return -1;
	
	}

}

public Native_ForceDropHeldEntity(Handle:plugin,  args){

	new client = GetNativeCell(1);
	
	if(isClientConnectedIngameAlive(client)){
	
		release(client);
		return true;
	}
	
	return false;

}

public Native_ForceGrabEntity(Handle:plugin,  args){

	new client = GetNativeCell(1);
	new entity = GetNativeCell(2);
	
	if(isClientConnectedIngameAlive(client)){
		
		if(IsValidEdict(entity)){
			
			new PropTypeCheck:entityType = entityTypeCheck(entity);
			
			if(entityType && !isClientConnectedIngameAlive(GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity"))){
			
				//지목한 엔티티는 들 수 있는것이다.
				//이미 들고있는 엔티티가 있다면, 내려놓는다
				release(client);
				
				grabentitytype[client] = entityType;
				grabbedentref[client] = EntIndexToEntRef(entity);
				
				//소리를 낸다
				playsoundfromclient(client, SOUNDTYPE_GRAVITYGUN_PICKUP);
				playentitysoundfromclient(client, SOUND_GRAVITYGUN_HOLD);
				
				return true;
			
			}
		
		}
		
	}
	
	return false;

}